-- I wonder what this is for?
-- I kid, I kid, this is obviously for SRB2Persona!
-- Hey, you bothered checking the files. If this is included in an unrelated character release, surely this means something... right?
-- PS: SRB2P custom character support works, but is rough.
-- There are NO failsafes if you fuck up declarations, so read the comments here.
freeslot("sfx_dtnwin", "SPR_PDET")

if not srb2p return end
-- Due to the exe nature of the mod, this only requires a one-time check.
VFX_freeslotC("deton")
-- Define our base character's stats!
charStats["deton"] = {

		-- GENERAL

		name = "Deton",		-- This is only for bots / enemies
		basehp = 70,			-- base HP for level 1 (Cannot be <= 0)
		basesp = 28,			-- base SP for level 1 (Can be 0, but not < 0!)
		persona = "bigton",		-- Persona to use
		melee_natk = "metal_atk1",	-- normal melee attack

		-- Normal attack attributes
		-- Scales with game difficulty
		atk = 35,	-- power (generally < 50)
		acc = 80,	-- accuracy (%)
		crit = 2,	-- crit rate (%)

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame, ["SPR2_CONST"]}
		-- (SPR2 must be a string, and is optional. Only for use with SPR_PLAY)

		-- Note: As of Beta 1.0.0, not all animations are implemented
		-- (* = unimplemented)

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},		-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},		-- standing (low HP)
		anim_stand_bored =	{SPR_PLAY, A, B, C, D, E, F, G, H, I, J, K, L, M, N, 8, "SPR2_WAIT"},	-- standing (rare anim)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_RIDE"},		-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},		-- moving
		anim_run =			{SPR_PLAY, A, 1, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},	-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 1, "SPR2_PAIN"},	-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, B, C, D, A, B, C, D, 2, "SPR2_PAIN"},		-- taking damage
		anim_getdown =		{SPR_PLAY, A, 1, "SPR2_SHIT"},		-- knocked down from weakness / crit
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_SHIT"},		-- is down
		anim_getup =		{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},		-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},		-- dies
		anim_revive =		{SPR_PLAY, A, B, C, D, 2, "SPR2_ROLL"},		-- gets revived
		anim_evoker =		{SPR_PLAY, A, 1, "SPR2_WAIT"},	-- holding evoker to head
		anim_evoker_shoot =	{SPR_PLAY, B, C, D, E, F, G, H, I, J, K, L, M, N, 2, "SPR2_WAIT"},		-- shooting evoker

		anim_stand_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},		-- standing
		anim_stand_hurt_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},		-- standing
		anim_stand_bored_super = 	{SPR_PLAY, A, B, C, D, E, F, G, H, I, J, K, L, M, N, 4, "SPR2_WAIT"},		-- standing
		anim_run_super = 	{SPR_PLAY, A, 1, "SPR2_RUN_"},	-- run
		anim_evoker_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},
		anim_evoker_shoot_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},

		anim_special1 = {SPR_PLAY, A, B, C, D, E, F, G, H, I, J, K, L, M, N, A, B, C, D, E, F, G, H, I, J, K, L, M, N, 6, "SPR2_WAIT"}, -- First dance
		anim_special2 = {SPR_PLAY, A, B, C, D, E, F, G, H, I, J, K, L, M, N, A, B, C, D, E, F, G, H, I, J, K, L, M, N, A, B, C, D, E, F, G, H, I, J, K, L, M, N, 4, "SPR2_WAIT"}, -- second dance
		anim_special3 = {SPR_PLAY, A, B, C, D, E, F, G, H, I, J, K, L, M, N, A, B, C, D, E, F, G, H, I, J, K, L, M, N, A, B, C, D, E, F, G, H, I, J, K, L, M, N, A, B, C, D, E, F, G, H, I, J, K, L, M, N, 2, "SPR2_WAIT"}, -- third dance

		-- VOICES
		-- Possible list of voices
		-- vfx_action = {"sfx_voice1", "sfx_voice2", [...], "sfx_voicen"}

		vfx_summon = {"sfx_deton"},	-- Summoning Persona to use a Skill
        vfx_skill = {"sfx_deton"},		-- Used a Skill
        vfx_item = {"sfx_deton"},		-- Used an item
        vfx_hurt = {"sfx_dtnbom"},		-- Sustained damage
        vfx_hurtx = {"sfx_deton"},		-- Sustained heavy damage / Critical hit / Weakness
        vfx_die = {"sfx_dtnbom"}, -- die
        vfx_heal = {"sfx_deton"},		-- Healed by teammate
        vfx_healself = {"sfx_deton"},	-- Healed self
        vfx_kill = {"sfx_deton"},		-- Killed an enemy
        vfx_1more = {"sfx_dtnbom"},		-- Performed 1more
        vfx_crit = {"sfx_deton"},		-- Cut-in for Weakness/Critical Hit
        vfx_aoaask = {"sfx_deton"},	-- Ask to All-Out Attack
        vfx_aoado = {"sfx_dtnbom"},		-- Performing All-Out Attack
        vfx_aoarelent = {"sfx_deton"},	-- Relenting from All-Out Attack
        vfx_miss = {"sfx_deton"},		-- Missed attack
        vfx_dodge = {"sfx_deton"},		-- Dodged enemy attack
        vfx_win = {"sfx_dtnwin"},		-- Battle won
        vfx_levelup = {"sfx_dtnwin"},	-- level up?


		-- HUD DEFINTIIONS

		icon = "ICO_DTON",	-- icon for net select and other menus
		hudbust = "DTN_H",			-- patch to draw on the stat hud
		hudbustlayer = "",		-- transparent patch to draw for status conditions
		hudaoa = "H_DTNAOA",	-- patch for all out attack hud
		hudcutin = "DTON_A",	-- cut in
		hudspr = "DTON",	-- sprite prefix since hud can't retrieve it. yikes
		aoa_quote = "*Deton starts grooving \nviolently.*",	-- wity quote shown when character asks for an AOA
					
		-- Tip to display on the character select.
		-- Give insight on their skill type and their strengths/weaknesses in battle!
		tip = "This grooving explosive device \ncan learn Nuclear and Buff skills, \nwith some other moves sprinkled in.\nThanks to being a robot, Deton can \nwithstand most physical attacks. \n(this is mostly a metal clone though lol)",
}


personaList["bigton"] = {
		-- GENERAL
		name = "bigton",
		arcana = ARCANA_CHARIOT,

		-- STATS (at level 10. so we can have some precision, y'see)

		sprite = SPR_PDET,
		anim_idle = 	{SPR_PDET, A, J, 20, "SPR_PDET"},
		anim_atk = 		{SPR_PDET, B, C, D, E, F, G, H, I, B, 2, "SPR_PDET"},
		startframe = 0,

		strength = 10,
		magic = 8,
		endurance = 11,
		luck = 4,
		agility = 7,
		weak = ATK_ELEC|ATK_FIRE,
		resist = ATK_STRIKE|ATK_PIERCE|ATK_SLASH|ATK_NUCLEAR,
		skills = {
					{"frei", 1}, {"snap", 1},
					{"sukukaja", 1}, {"last resort", 1},
					{"groove", 12}, {"dekunda", 15}, 
					{"kill rush", 17}, {"assault dive", 22},
									 

					{"freila", 28, "snap"}, {"masukukaja", 32, "frei"},
					{"marakukaja", 35, "sukukaja"}, {"schmoove", 38, "groove"},
					{"panty raid", 45},
					{"power charge", 47, "assault dive"},
					{"gigantic fist", 53, "kill rush"},
					{":detondance:", 54, "schmoove"},
					{"vicious strike", 57, "heat wave"},
					{"freidyne", 62, "freila"},
					{"god hand", 68, "gigantic fist"},
					{"akasha arts", 72, "vicious strike"},
				},
}

attackDefs["groove"] = {
		name = "Groove",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 4,
		power = 50,
		desc = "Slight HP recovery to one ally.",
		target = TGT_ALLY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 1
				ANIM_set(mo, mo.anim_special1)
			end
			if timer == 20
				target.heal_rings = {}
			elseif timer >= 21
			and timer < 70
				if timer < 40
					--for i = 1, 2
						local x, y, z = mo.x + P_RandomRange(-400,400)<<FRACBITS, mo.y + P_RandomRange(-400,400)<<FRACBITS, mo.z + P_RandomRange(0, 400)<<FRACBITS
						local r = P_SpawnMobj(x, y, z, MT_DUMMY)
						r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
						r.state = S_RING
						r.target = target
						r.tracer = target

						local dist = P_AproxDistance(P_AproxDistance(target.x - r.x, target.y - r.y), target.z - r.z)
						r.momx = FixedMul(FixedDiv(target.x - r.x, dist), 32<<FRACBITS)
						r.momy = FixedMul(FixedDiv(target.y - r.y, dist), 32<<FRACBITS)
						r.momz = FixedMul(FixedDiv(target.z - r.z, dist), 32<<FRACBITS)
						r.fuse = 20

						--A_HomingChase(r, FRACUNIT*32)
						r.scale = 1
						r.destscale = FRACUNIT
						r.scalespeed = FRACUNIT/4
						target.heal_rings[#target.heal_rings+1] = r
					--end
				end
				for i = 1, #target.heal_rings
					local r = target.heal_rings[i]
					if not r or not r.valid continue end
					if R_PointToDist2(target.x, target.y, r.x, r.y) < 40<<FRACBITS
					and abs(r.z - mo.z) < 40<<FRACBITS
						playSound(mo.battlen, sfx_itemup)
						r.state = S_SPRK1
						table.remove(target.heal_rings, i)
						i = $-1
					end
				end

			elseif timer == 70
				P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
				local heals = P_RandomRange(50, 60)
				playSound(mo.battlen, sfx_heal)
				damageObject(target, -heals)
			elseif timer == 120
				return true
			end
		end,
}
attackDefs["schmoove"] = {
		name = "Schmoove",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 12,
		power = 120,
		desc = "Moderate HP recovery to one ally.",
		target = TGT_ALLY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				ANIM_set(mo, mo.anim_special2)
			end
			if timer == 20
				target.heal_rings = {}
			elseif timer >= 21
			and timer < 70
				if timer < 40
					--for i = 1, 2
						local x, y, z = mo.x + P_RandomRange(-400,400)<<FRACBITS, mo.y + P_RandomRange(-400,400)<<FRACBITS, mo.z + P_RandomRange(0, 400)<<FRACBITS
						local r = P_SpawnMobj(x, y, z, MT_DUMMY)
						r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
						r.state = S_RING
						r.target = target
						r.tracer = target

						local dist = P_AproxDistance(P_AproxDistance(target.x - r.x, target.y - r.y), target.z - r.z)
						r.momx = FixedMul(FixedDiv(target.x - r.x, dist), 32<<FRACBITS)
						r.momy = FixedMul(FixedDiv(target.y - r.y, dist), 32<<FRACBITS)
						r.momz = FixedMul(FixedDiv(target.z - r.z, dist), 32<<FRACBITS)
						r.fuse = 20

						--A_HomingChase(r, FRACUNIT*32)
						r.scale = 1
						r.destscale = FRACUNIT
						r.scalespeed = FRACUNIT/4
						target.heal_rings[#target.heal_rings+1] = r
					--end
				end
				for i = 1, #target.heal_rings
					local r = target.heal_rings[i]
					if not r or not r.valid continue end
					if R_PointToDist2(target.x, target.y, r.x, r.y) < 40<<FRACBITS
					and abs(r.z - mo.z) < 40<<FRACBITS
						playSound(mo.battlen, sfx_itemup)
						r.state = S_SPRK1
						table.remove(target.heal_rings, i)
						i = $-1
					end
				end

			elseif timer == 70
				P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
				local heals = P_RandomRange(50, 60)
				playSound(mo.battlen, sfx_heal)
				damageObject(target, -heals)
			elseif timer == 120
				return true
			end
		end,
}
attackDefs[":detondance:"] = {
		name = ":detondance:",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 28,
		power = 250,
		desc = "Large HP recovery to one ally.",
		target = TGT_ALLY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
		
			if timer == 1
				ANIM_set(mo, mo.anim_special3)
			end
			if timer == 20
				target.heal_rings = {}
			elseif timer >= 21
			and timer < 70
				if timer < 40
					--for i = 1, 2
						local x, y, z = mo.x + P_RandomRange(-400,400)<<FRACBITS, mo.y + P_RandomRange(-400,400)<<FRACBITS, mo.z + P_RandomRange(0, 400)<<FRACBITS
						local r = P_SpawnMobj(x, y, z, MT_DUMMY)
						r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
						r.state = S_RING
						r.target = target
						r.tracer = target

						local dist = P_AproxDistance(P_AproxDistance(target.x - r.x, target.y - r.y), target.z - r.z)
						r.momx = FixedMul(FixedDiv(target.x - r.x, dist), 32<<FRACBITS)
						r.momy = FixedMul(FixedDiv(target.y - r.y, dist), 32<<FRACBITS)
						r.momz = FixedMul(FixedDiv(target.z - r.z, dist), 32<<FRACBITS)
						r.fuse = 20

						--A_HomingChase(r, FRACUNIT*32)
						r.scale = 1
						r.destscale = FRACUNIT
						r.scalespeed = FRACUNIT/4
						target.heal_rings[#target.heal_rings+1] = r
					--end
				end
				for i = 1, #target.heal_rings
					local r = target.heal_rings[i]
					if not r or not r.valid continue end
					if R_PointToDist2(target.x, target.y, r.x, r.y) < 40<<FRACBITS
					and abs(r.z - mo.z) < 40<<FRACBITS
						playSound(mo.battlen, sfx_itemup)
						r.state = S_SPRK1
						table.remove(target.heal_rings, i)
						i = $-1
					end
				end

			elseif timer == 70
				P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
				local heals = P_RandomRange(50, 60)
				playSound(mo.battlen, sfx_heal)
				damageObject(target, -heals)
			elseif timer == 120
				return true
			end
		end,
}